import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import ftcomputing.robo.*;

/**
 * Industry Robot an Robo Interface : Betrieb ber Swing-Buttons
 * 
 * @author Ulrich Mller
 * @version Java 6 - BlueJ - 09.04.10
 */
public class RobTouch extends JFrame 
    implements MouseListener, WindowListener {
    
    // --- Globale Variable ----
    private JLabel lblStatus;
    private JButton cmdAuf;
    private JButton cmdRauf;
    private JButton cmdVor;
    private JButton cmdLinks;
    private JButton cmdHome;
    private JButton cmdRechts;
    private JButton cmdZu;
    private JButton cmdRunter;
    private JButton cmdRueck;
    
    private FishFace ft;

    // --- Konstruktor ---
    public RobTouch(int x, int y) {
        super("RobTouch");

        // --- Frame mit BorderLayout und WindowListener, 
        //     Programmende bei Fenster zu
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(new BorderLayout());
        setSize(x, y);
        addWindowListener(this);
        
        // --- Info-Panel mit Status-Label, oben im Frame
        JPanel pnlInfo = new JPanel();
        add(pnlInfo, BorderLayout.NORTH);
        lblStatus = new JLabel("Ready", JLabel.CENTER);
        pnlInfo.add(lblStatus);
        
        // --- Haupt-Panel mit Buttons, 
        //     GridLayout zur Plazierung der Buttons, unten
        JPanel pnlMain = new JPanel();
        pnlMain.setLayout(new GridLayout(3, 3));
        add(pnlMain, BorderLayout.SOUTH);
        
        // --- Button fr pnlMain mit MouseListener ---
        cmdAuf = new JButton("AUF");
        cmdAuf.addMouseListener(this);
        pnlMain.add(cmdAuf);
        cmdRauf = new JButton("RAUF");
        cmdRauf.addMouseListener(this);
        pnlMain.add(cmdRauf);
        cmdVor = new JButton("VOR");
        cmdVor.addMouseListener(this);
        pnlMain.add(cmdVor);
        cmdLinks = new JButton("LINKS");
        cmdLinks.addMouseListener(this);
        pnlMain.add(cmdLinks);
        cmdHome = new JButton("HOME");
        cmdHome.addMouseListener(this);
        pnlMain.add(cmdHome);
        cmdRechts = new JButton("RECHTS");
        cmdRechts.addMouseListener(this);
        pnlMain.add(cmdRechts);
        cmdZu = new JButton("ZU");
        cmdZu.addMouseListener(this);
        pnlMain.add(cmdZu);
        cmdRunter = new JButton("RUNTER");
        cmdRunter.addMouseListener(this);
        pnlMain.add(cmdRunter);
        cmdRueck = new JButton("RCK");
        cmdRueck.addMouseListener(this);
        pnlMain.add(cmdRueck);
               
        // --- FishFace Open ---
        ft = new FishFace();
        ft.openInterface(0, 0);
    }
    
    // --- Start-Routine des Programms ---
    public static void main() {
        JFrame frm = new RobTouch(320, 160);
        frm.setLocation(300, 200);
        frm.setVisible(true);
    }
    
    // --- EreignisRoutinen des MouseListeners ---
    public void mousePressed(MouseEvent e) {
        Object cmd = e.getSource();
        if(cmd == cmdAuf) {
            lblStatus.setText("Greifer ffnet");
            ft.setMotor(Mot.M4, Dir.Left, Speed.Full, 9999);
        }
        else if(cmd == cmdRauf) {
            lblStatus.setText("Arm geht nach oben");
            ft.setMotor(Mot.M3, Dir.Left);
        }
        else if(cmd == cmdVor) {
            lblStatus.setText("Arm geht vor");
            ft.setMotor(Mot.M2, Dir.Right);
        }
        else if(cmd == cmdLinks) {
            lblStatus.setText("Sule dreht nach links");
            ft.setMotor(Mot.M1, Dir.Left);
        }
        else if(cmd == cmdHome) {
            lblStatus.setText("Robot fhrt auf Home-Position");
            ft.setMotor(Mot.M1, Dir.Left, Speed.Full, 9999);
            ft.setMotor(Mot.M2, Dir.Left, Speed.Full, 9999);
            ft.setMotor(Mot.M3, Dir.Left, Speed.Full, 9999);
            ft.setMotor(Mot.M4, Dir.Left, Speed.Full, 9999);
        }
        else if(cmd == cmdRechts) {
            lblStatus.setText("Sule dreht nach rechts");
            ft.setMotor(Mot.M1, Dir.Right);
        }
        else if(cmd == cmdZu) {
            lblStatus.setText("Greifer schliet");
            ft.setMotor(Mot.M4, Dir.Right, Speed.Full, 26);
        }
        else if(cmd == cmdRunter) {
            lblStatus.setText("Arm geht nach unten");
            ft.setMotor(Mot.M3, Dir.Right);
        }
        else if(cmd == cmdRueck) {
            lblStatus.setText("Arm geht nach hinten");
            ft.setMotor(Mot.M2, Dir.Left);
        }
    }
    public void mouseReleased(MouseEvent e) {
        Object cmd = e.getSource();
        if(cmd == cmdAuf)         ft.waitForMotors(0, Mot.M4);
        else if(cmd == cmdRauf)   ft.setMotor(Mot.M3, Dir.Off);
        else if(cmd == cmdVor)    ft.setMotor(Mot.M2, Dir.Off);
        else if(cmd == cmdLinks)  ft.setMotor(Mot.M1, Dir.Off);
        else if(cmd == cmdHome)   
                ft.waitForMotors(0, Mot.M1, Mot.M2, Mot.M3, Mot.M4);   
        else if(cmd == cmdRechts) ft.setMotor(Mot.M1, Dir.Off);
        else if(cmd == cmdZu)     ft.waitForMotors(0, Mot.M4);
        else if(cmd == cmdRunter) ft.setMotor(Mot.M3, Dir.Off);
        else if(cmd == cmdRueck)  ft.setMotor(Mot.M2, Dir.Off);        
        lblStatus.setText("Idle");
    }
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}

    // --- EreignisRoutinen des WindowListeners ---
    public void windowClosing(WindowEvent e) {
        ft.closeInterface();
    }
    public void windowClosed(WindowEvent e) {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {}
    public void windowActivated(WindowEvent e) {}
    public void windowDeactivated(WindowEvent e) {}
    public void windowOpened(WindowEvent e) {}
}
