// ----------------------------------------------------------------------------
//
// RobTeach                                           Ulrich Mller    15.04.10
//                                                    Aspire Java 6 Eclipse 3.4
// Industry Robot TeachIn
// Robo Interface - FishFace
//
// ----------------------------------------------------------------------------
package RobTeach;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import ftcomputing.robo.*;

public class RobTeach extends JFrame implements WindowListener, MouseListener {
 	private static final long serialVersionUID = -3926082660134197261L;
	// --- Globale Variable ----
 	private JLabel lblStatus;
    private JButton cmdRun;
    private JButton cmdClear;
    private JButton cmdAdd;
 	private JButton cmdAuf;
    private JButton cmdRauf;
    private JButton cmdVor;
    private JButton cmdLinks;
    private JButton cmdHome;
    private JButton cmdRechts;
    private JButton cmdZu;
    private JButton cmdRunter;
    private JButton cmdRueck;

    private FishFace ft;
    private int[] actPos = new int[4];
    private static final int GripClosed = 26;
    private int[][] robListe = new int[100][4];
    private int anzPos;
    private int gripOpen;
    
    // --- Konstruktor ---
    public RobTeach(int x, int y) {
        setTitle("RobTeach");

        // --- Frame mit BorderLayout und WindowListener, 
        //     Programmende bei Fenster zu
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(new BorderLayout());
        setSize(x, y);
        addWindowListener(this);
        
        // --- Info-Panel mit Status-Label, oben im Frame
        JPanel pnlInfo = new JPanel();
        add(pnlInfo, BorderLayout.NORTH);
        lblStatus = new JLabel("Ready", JLabel.CENTER);
        pnlInfo.add(lblStatus);
        
        // --- Haupt-Panel mit Buttons, 
        //     GridLayout zur Plazierung der Buttons, unten
        JPanel pnlMain = new JPanel();
        pnlMain.setLayout(new GridLayout(4, 3));
        add(pnlMain, BorderLayout.SOUTH);
        
        // --- Button fr pnlMain mit MouseListener ---
        cmdRun = new JButton("RUN");
        cmdRun.addMouseListener(this);
        pnlMain.add(cmdRun);
        cmdClear = new JButton("CLEAR");
        cmdClear.addMouseListener(this);
        pnlMain.add(cmdClear);
        cmdAdd = new JButton("ADD");
        cmdAdd.addMouseListener(this);
        pnlMain.add(cmdAdd);
        cmdAuf = new JButton("AUF");
        cmdAuf.addMouseListener(this);
        pnlMain.add(cmdAuf);
        cmdRauf = new JButton("RAUF");
        cmdRauf.addMouseListener(this);
        pnlMain.add(cmdRauf);
        cmdVor = new JButton("VOR");
        cmdVor.addMouseListener(this);
        pnlMain.add(cmdVor);
        cmdLinks = new JButton("LINKS");
        cmdLinks.addMouseListener(this);
        pnlMain.add(cmdLinks);
        cmdHome = new JButton("HOME");
        cmdHome.addMouseListener(this);
        pnlMain.add(cmdHome);
        cmdRechts = new JButton("RECHTS");
        cmdRechts.addMouseListener(this);
        pnlMain.add(cmdRechts);
        cmdZu = new JButton("ZU");
        cmdZu.addMouseListener(this);
        pnlMain.add(cmdZu);
        cmdRunter = new JButton("RUNTER");
        cmdRunter.addMouseListener(this);
        pnlMain.add(cmdRunter);
        cmdRueck = new JButton("RCK");
        cmdRueck.addMouseListener(this);
        pnlMain.add(cmdRueck);
               
        // --- FishFace Open ---
        ft = new FishFace();
        ft.openInterface(0, 0);
    }

    
    // --- Start-Routine des Programms ---
    public static void main(String param[]) {
        JFrame frm = new RobTeach(320, 180);
        frm.setLocation(320, 200);
        frm.setVisible(true);
    }
    
    
    // --- EreignisRoutinen des MouseListeners ---
    public void mousePressed(MouseEvent e) {
        Object cmd = e.getSource();
        if(cmd == cmdAuf) {
            lblStatus.setText("Greifer ffnet");
            ft.setMotor(Mot.M4, Dir.Left, Speed.Full, 9999);
        }
        else if(cmd == cmdRauf) {
            lblStatus.setText("Arm geht nach oben");
            ft.setMotor(Mot.M3, Dir.Left, Speed.Full, 9999);
        }
        else if(cmd == cmdVor) {
            lblStatus.setText("Arm geht vor");
            ft.setMotor(Mot.M2, Dir.Right, Speed.Full, 9999);
        }
        else if(cmd == cmdLinks) {
            lblStatus.setText("Sule dreht nach links");
            ft.setMotor(Mot.M1, Dir.Left, Speed.Full, 9999);
        }
        else if(cmd == cmdHome) {
            lblStatus.setText("Robot fhrt auf Home-Position");
            ft.setMotor(Mot.M1, Dir.Left, Speed.Full, 9999);
            ft.setMotor(Mot.M2, Dir.Left, Speed.Full, 9999);
            ft.setMotor(Mot.M3, Dir.Left, Speed.Full, 9999);
            ft.setMotor(Mot.M4, Dir.Left, Speed.Full, 9999);
        }
        else if(cmd == cmdRechts) {
            lblStatus.setText("Sule dreht nach rechts");
            ft.setMotor(Mot.M1, Dir.Right, Speed.Full, 9999);
        }
        else if(cmd == cmdZu) {
            lblStatus.setText("Greifer schliet");
            ft.setMotor(Mot.M4, Dir.Right, Speed.Full, GripClosed);
        }
        else if(cmd == cmdRunter) {
            lblStatus.setText("Arm geht nach unten");
            ft.setMotor(Mot.M3, Dir.Right, Speed.Full, 9999);
        }
        else if(cmd == cmdRueck) {
            lblStatus.setText("Arm geht nach hinten");
            ft.setMotor(Mot.M2, Dir.Left, Speed.Full, 9999);
        }
    }
    public void mouseReleased(MouseEvent e) {
        Object cmd = e.getSource();
        if(cmd == cmdAuf) {
            ft.waitForMotors(0, Mot.M4);
            actPos[Mot.M4-1] = 0;
            lblStatus.setText("Greifer geffnet");
        }
        else if(cmd == cmdRauf)   {
            ft.setMotor(Mot.M3, Dir.Off);
            actPos[Mot.M3-1] -= 9999 - ft.getCounter(Inp.I6);
            if(actPos[Mot.M3-1] < 0) actPos[Mot.M3-1] = 0;
            lblStatus.setText("Arm vertikal : " + actPos[Mot.M3-1]);
        }
        else if(cmd == cmdVor) {
            ft.setMotor(Mot.M2, Dir.Off);
            actPos[Mot.M2-1] += 9999 - ft.getCounter(Inp.I4);
            lblStatus.setText("Arm horizontal : " + actPos[Mot.M2-1]);
        }
        else if(cmd == cmdLinks) {
            ft.setMotor(Mot.M1, Dir.Off);
            actPos[Mot.M1-1] -= 9999 - ft.getCounter(Inp.I2);
            if(actPos[Mot.M1-1] < 0) actPos[Mot.M1-1] = 0;
            lblStatus.setText("Sule : " + actPos[Mot.M1-1]);
        }
        else if(cmd == cmdHome)   {
            ft.waitForMotors(0, Mot.M1, Mot.M2, Mot.M3, Mot.M4);
            for(int i = 0; i < actPos.length; i++) actPos[i] = 0;
            lblStatus.setText("Robot auf Home-Position");
        }
        else if(cmd == cmdRechts) {
            ft.setMotor(Mot.M1, Dir.Off);
            actPos[Mot.M1-1] += 9999 - ft.getCounter(Inp.I2);
            lblStatus.setText("Sule : " + actPos[Mot.M1-1]);
        }
        else if(cmd == cmdZu) {
            ft.waitForMotors(0, Mot.M4);
            actPos[Mot.M4-1] = GripClosed;
            lblStatus.setText("Greifer geschlossen");
        }
        else if(cmd == cmdRunter) {
            ft.setMotor(Mot.M3, Dir.Off);
            actPos[Mot.M3-1] += 9999 - ft.getCounter(Inp.I6);
            lblStatus.setText("Arm vertikal : " + actPos[Mot.M3-1]);
        }
        else if(cmd == cmdRueck) {
            ft.setMotor(Mot.M2, Dir.Off);        
            actPos[Mot.M2-1] -= 9999 - ft.getCounter(Inp.I4);
            if(actPos[Mot.M2-1] < 0) actPos[Mot.M2-1] = 0;
            lblStatus.setText("Arm horizontal : " + actPos[Mot.M2-1]);
        }
    }
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {
        Object cmd = e.getSource();
        if(cmd == cmdRun) {
        	runListe();
       }
        else if(cmd == cmdClear) {
        	anzPos = 0;
        	lblStatus.setText("robListe gelscht");
        }
        else if(cmd == cmdAdd) {
        	for(int i = 0; i < 4; i++) {
        		robListe[anzPos][i] = actPos[i];
        	}
        	if(anzPos < (robListe.length-1)) anzPos++;
        	lblStatus.setText("Lnge robListe : " + anzPos);
        }
    }
    private void runListe()  {
        for(int i = 0; i < anzPos; i++) {
        	for(int j = 0; j < 3; j++) {
        		int zPos = robListe[i][j];
        		if(zPos < actPos[j])
        			ft.setMotor(j+1, Dir.Left,Speed.Full, actPos[j]-zPos);
        		else if(zPos > actPos[j])
        			ft.setMotor(j+1, Dir.Right, Speed.Full, zPos-actPos[j]);
        	}
        	ft.waitForMotors(0, Mot.M1, Mot.M2, Mot.M3);
        	for(int j = 0; j < 3; j++) actPos[j] = robListe[i][j];
        	if(robListe[i][3] == 0) {
        		ft.setMotor(Mot.M4, Dir.Left, Speed.Full, 9999);
        		ft.waitForMotors(0, Mot.M4);
        		gripOpen = 0;
        	} else if(gripOpen == 0){
        		ft.setMotor(Mot.M4, Dir.Right, Speed.Full, GripClosed);
        		ft.waitForMotors(0, Mot.M4);
        		gripOpen = GripClosed;
        	}
           	lblStatus.setText("Run : " + i);
        }   		
    }

    // --- EreignisRoutinen des WindowListeners ---
    public void windowClosing(WindowEvent e) {}
    public void windowClosed(WindowEvent e) {
    	ft.closeInterface();
    }
    public void windowDeiconified(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {}
    public void windowActivated(WindowEvent e) {}
    public void windowDeactivated(WindowEvent e) {}
    public void windowOpened(WindowEvent e) {}
}
